﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using MaxIm;

namespace MxPlugin_ListDocs1
{

    // COM Required Attributes for a custom coclass Interface
    // You must replace this GUID with a custom value.
    // Go to "Tools" > "Create GUID" to create your own.
    [Guid("B8C0B885-1835-4CF7-98B2-51940C2F4F28")]
    [CoClass(typeof(PlugIn))]
    [ComImport]
    [InterfaceType(ComInterfaceType.InterfaceIsDual)]
    public interface _PlugIn
    {
        [DispId(0)] void DoModal([In, MarshalAs(UnmanagedType.Interface)] MaxIm.Document doc);

        [DispId(1)]
        [return: MarshalAs(UnmanagedType.BStr)]
        string Name();
    }

    // The coclass implementation of the COM Interface.
    // You must replace this GUID with a custom value.
    // Go to "Tools" > "Create GUID" to create your own.
    [Guid("D54A76D0-8956-41B6-8652-E35587F9E663")]
    [ClassInterface(ClassInterfaceType.AutoDual)]
    public class PlugIn : _PlugIn
    {
        /*!
         * \brief Class constructor
         * Default class contructor must be implemented for COM objects.
         */
        public PlugIn()
        {
            // Initialize the COM object.
        }

        /*!
         * \brief Function executed on PlugIn execute call.
         * DoModal is the function call passed through the COM to the PlugIn. Takes the currently open MaxIm DL document as an argument. 
         * \param MaxIm.Document doc Document to execute the plugin on. Provides direct access to the Image Buffer SAFEARRAY, rather than through a VARIANT array. 
         *        Is the open document with current focus in MaxIm DL.
         */
        public void DoModal(MaxIm.Document doc)
        {
            // Do stuff here.

            string myStr = "";

            MaxIm.Application myApp = new MaxIm.Application();
            MaxIm.Documents myDocs = myApp.Documents;

            int docsCount = myDocs.Count();
            myStr = docsCount.ToString() + " documents\n";

            MaxIm.Document doc2 = null;
            for (int i = 1; i <= docsCount; i++)
            {
                doc2 = (MaxIm.Document)(object)(myDocs.Item(i));
                myStr = myStr + doc2.DisplayName + "\n";

            }
            MessageBox.Show(myStr);
            _ = Marshal.ReleaseComObject(doc2);
            _ = Marshal.ReleaseComObject(myDocs);
            _ = Marshal.ReleaseComObject(myApp);
        }


        /*!
         * \brief Returns the name of the PlugIn for use in the MaxIm DL GUI.
         * Returns the name of the PlugIn for use in the MaxIm DL GUI.
         */
        public string Name()
        {
            return "MaxIm DL Sample C# Plugin - ListDocs1";
        }
    }
}

